%% Based on wegcLaTeX by Michael H. Pock
%% Contributions from Lukas Brunner (2018)
%% Additional changes by Florian Ladstädter (2018, 2022)

\ProvidesPackage{wlatex}


%%\RequirePackage{lipsum}
%% --> http://tug.ctan.org/tex-archive/macros/latex/contrib/lipsum/lipsum.pdf


\RequirePackage{lmodern}
%% --> http://www.tug.org/TUGboat/Articles/tb24-1/jackowski.pdf
%% --> http://tug.ctan.org/tex-archive/fonts/ps-type1/lm/doc/fonts/lm/lm-info.pdf
%% --> http://www.tug.org/pracjourn/2006-1/robertson/robertson.pdf


\RequirePackage[T1]{fontenc}
%% --> http://tug.ctan.org/tex-archive/macros/latex/doc/fntguide.pdf
%% --> http://tug.ctan.org/tex-archive/macros/latex/doc/encguide.pdf


\RequirePackage{textcomp}
%% --> http://tug.ctan.org/tex-archive/macros/latex/doc/encguide.pdf
%% --> http://tug.ctan.org/tex-archive/info/symbols/comprehensive/symbols-a4.pdf


\RequirePackage[utf8]{inputenx}
%% --> http://tug.ctan.org/tex-archive/macros/latex/contrib/oberdiek/inputenx.pdf


\RequirePackage[strict, threshold=0]{csquotes}
%% threshold: regulates when \blockquote offsets quotes (here: always)
%% --> http://tug.ctan.org/tex-archive/macros/latex/contrib/csquotes/csquotes.pdf


\RequirePackage{datetime2}
%% --> http://mirrors.ctan.org/macros/latex/contrib/datetime2/datetime2.pdf


\RequirePackage[rgb, svgnames, x11names, table]{xcolor}
%% --> http://mirrors.ctan.org/macros/latex/contrib/xcolor/xcolor.pdf


\RequirePackage[pdftex]{graphicx}
%% --> http://tug.ctan.org/tex-archive/macros/latex/required/graphics/grfguide.pdf
%% --> http://tug.ctan.org/tex-archive/info/epslatex/english/epslatex.pdf


\RequirePackage{amsmath}
%% --> http://mirrors.ctan.org/macros/latex/required/amsmath/amsmath.pdf


\RequirePackage{mathtools}
%% --> http://mirrors.ctan.org/macros/latex/contrib/mathtools/mathtools.pdf


\RequirePackage{bm}
%% --> http://mirrors.ctan.org/macros/latex/required/tools/bm.pdf


\RequirePackage{amssymb}
%% --> http://mirrors.ctan.org/fonts/amsfonts/doc/amsfonts.pdf
%% --> http://mirrors.ctan.org/fonts/amsfonts/doc/amsfndoc.pdf


\RequirePackage[rmdefault]{mathcomp}
%% --> http://mirrors.ctan.org/macros/latex/contrib/mathcomp/mathcomp.pdf


\RequirePackage{siunitx}
%% --> http://tug.ctan.org/tex-archive/macros/latex/contrib/siunitx/siunitx.pdf
%% \sisetup{
%%   separate-uncertainty,
%%   multi-part-units=repeat,
%%   detect-weight=true,
%% }
%% \newcommand{\SItimes}[3]{\SI{#1}{#3}$\times$\SI{#2}{#3}}


\RequirePackage[hyphens, obeyspaces, spaces]{url}
% %% --> http://tug.ctan.org/tex-archive/macros/latex/contrib/url/url.pdf
\urlstyle{sf}


%% NOTE: 'Class scrbook Warning: \float@addtolists detected!'
%% listings does not support tocbasic
%% \RequirePackage[savemem]{listings}
%% --> http://mirrors.ctan.org/macros/latex/contrib/listings/listings.pdf

\PassOptionsToPackage{
  %% no colored frame around links
  colorlinks,
  %% internal link color
  linkcolor=black,
  %% cite color
  citecolor=blue,
  %% file link color
  filecolor=black,
  %% url link color
  urlcolor=blue,
  % make hyperref 'dumber' (to get internal links right when using \resetcounter)
  %% --> https://tex.stackexchange.com/questions/6098/wrong-hyper-references-after-resetting-chapter-counter
  % hypertexnames=false
}{hyperref}

\RequirePackage{hyperref}
% %% --> http://tug.ctan.org/tex-archive/macros/latex/contrib/hyperref/doc/manual.pdf
% %% --> http://tug.ctan.org/tex-archive/macros/latex/contrib/hyperref/doc/paper.pdf
% %% --> http://tug.ctan.org/tex-archive/macros/latex/contrib/hyperref/README.pdf


% UGO upload of thesis officially requires the PDF/A format.
% Until now normal PDFs never were a problem though.
% In theory this package can provide PDF/A from latex - but it's not
% really working at the moment.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %% Creates PDF/A
% %% Note: option clash with hyperref -> let pdfx load hyperref and pass on options
% \RequirePackage[a-3u]{pdfx}
% %% --> http://mirrors.ctan.org/macros/latex/contrib/pdfx/pdfx.pdf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\RequirePackage{tabularx}
%% --> http://mirrors.ctan.org/macros/latex/required/tools/tabularx.pdf


\RequirePackage{booktabs}
%% --> http://mirrors.ctan.org/macros/latex/contrib/booktabs/booktabs.pdf


\RequirePackage{longtable}
\RequirePackage{ltabptch}
%% --> http://mirrors.ctan.org/macros/latex/required/tools/longtable.pdf
%% --> http://mirrors.ctan.org/macros/latex/contrib/ltabptch/ltabptch.pdf


\RequirePackage{pdfpages}
%% --> http://mirrors.ctan.org/macros/latex/contrib/pdfpages/pdfpages.pdf


\RequirePackage{microtype}
%% --> http://mirrors.ctan.org/macros/latex/contrib/microtype/microtype.pdf


\AfterPackage*{hyperref}{%
  \RequirePackage[%
  nonumberlist,     % no page numbers in the glossaries
  acronym,          % separate acronym definitions
  shortcuts,        % This option provides shortcut commands for acronyms.
  nomain,           % suppresses the creation of the main glossary (only acronyms needed)
  hyperfirst=false  % don't link first use
  ]{glossaries}
}

%% --> http://mirrors.ctan.org/macros/latex/contrib/glossaries/glossaries-code.pdf
%% --> http://mirrors.ctan.org/macros/latex/contrib/glossaries/glossariesbegin.pdf
%% --> http://mirrors.ctan.org/macros/latex/contrib/glossaries/glossary2glossaries.pdf


%% no grouping of the acronyms w.r.t. first character in the list
\renewcommand*{\glsgroupskip}{}


%% enables the use of acronyms
\makeglossaries


\RequirePackage[
labelfont=bf,
format=plain,
font=small,
% listformat=empty % do not show number in LoF
]{caption}
%% --> http://mirrors.ctan.org/macros/latex/contrib/caption/caption-eng.pdf


%% KOMA headers and fooders
\RequirePackage{scrlayer-scrpage}
%% --> http://mirrors.ctan.org/macros/latex/contrib/koma-script/doc/scrguien.pdf


\RequirePackage[
style=authoryear,
maxcitenames=2,
maxbibnames=20,
giveninits=true,
backend=biber,
uniquename=false, % don't print initials for authors with same last name
uniquelist=false % set false to: Brunner, Steiner et al. -> Brunner et al.
]{biblatex}
%% --> http://mirrors.ctan.org/macros/latex/contrib/biblatex/doc/biblatex.pdf
%% --> http://mirrors.ctan.org/macros/latex/contrib/biblatex/CHANGES.org


%% spacing between bibliography entries
% \setlength{\bibitemsep}{5pt}


%% -------------------------------------------------------


%% avoiding widows and orphans (max 10000)
\clubpenalty = 5000
\widowpenalty = 5000
\displaywidowpenalty = 5000


%% suppress overfull hbox warnings (max 10000)
\hbadness=5000
\vbadness=5000


%% -------------------------------------------------------
%% additional features from Wegc-LaTeX


\AtBeginDocument{%
  \pdfstringdefDisableCommands{%
    \let\\\newline@pdfstringdef%
    \let\,\empty%
    \let\:\empty%
    \let\;\space%
    \def\and{, }%
    \let\thanks\@gobble%
    \let\thispagestyle\@gobble%
    \def\BibTeX{BibTeX}%
    \let\kerning\@gobbletwo%
    \let\@p\@gobble%
    \def\hyphen{-}%
    \def\nbhyphen{-}%
    \letcs{\textendash}{\f@encoding\string\textendash}%
    \letcs{\textemdash}{\f@encoding\string\textemdash}%
    \def\textfractionsolidus{/}%
    \let\hbspace\space%
    \def\hbhyphen{-}%
    \let\acronymfont\@firstofone%
    \let\noacronymfont\@firstofone%
  }%
}
